/*
 *  UFTP - UDP based FTP with multicast
 *
 *  Copyright (C) 2001-2010   Dennis A. Bush, Jr.   bush@tcnj.edu
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>

int optind=1;
char *optarg;

char getopt(int argc, char *argv[], char options[])
{
  char *loc;

  if (optind>=argc) {
    return -1;
  } else if (strlen(argv[optind])<=1) {
    return -1;
  } else if (argv[optind][0]!='-') {
    return -1;
  } else if (argv[optind][1]=='-') {
    optind++;
	return -1;
  } else if (!isalpha(argv[optind][1])) {
    return '?';
  } else if ((loc=strchr(options,argv[optind][1]))==NULL) {
	return '?';
  } else {
	optind++;
	if (loc[1]==':') {
      optarg=argv[optind++];
	}
	return loc[0];
  }
}

char *basename(char *pathname)
{
  static char *result;
  char *filename = NULL;
  DWORD len;

  free(result);
  len=0;
  len=GetFullPathNameA(pathname,len,result,&filename);

  result=malloc(len);
  if(result) {
    if(GetFullPathNameA(pathname,len,result,&filename) <= len) {
      return filename;
    }
  }
  return filename;
}
